/*
 * Hash.h
 *
 *  Created on: Jul 24, 2010
 *      Author: marco
 */

#ifndef HASH_H_
#define HASH_H_

#include <cstdlib>
#include <list>
#include <utility>
#include <algorithm>
#include <iterator>
#include <cmath>
#include "Definitions.h"
#include "Solution.h"
#include "Move.h"



//#define LARGE_PRIME 120011UL
//#define NEXT_PRIME 120017UL

#define LARGE_PRIME	1200007UL // w
#define NEXT_PRIME	1200061UL // m

#define size_hash int64_t  // guarantees up to 2,147,483,648


class compare_sum_per_colors: public binary_function<pair<Color, Longint > *&,
		pair<Color, Longint> *&, bool> {
public:
	//compare_components() {};
	virtual ~compare_sum_per_colors() {
	}
	;
	explicit compare_sum_per_colors() //Random *rn) :  r(rn)
	{
	}
	void sort(vector<pair<Color, Longint > *> &comps) {
		std::sort(comps.begin(), comps.end(), *this);
	}
	/*    std::vector<std::pair<Color,Longint> * >::iterator min(std::vector<std::pair<Color, Longint > * > &components)
	 {
	 return std::min_element(components.begin(), components.end(), (*this));
	 }
	 */

	bool operator()(pair<Color, Longint> * const &a,
			pair<Color, Longint> * const &b) {
		if (a->second < b->second)
			return true;
		else if (a->second == b->second) {
			if (a->first < b->first)
				return true;
			/*               else if (a.freeslots == b.freeslots)
			 {
			 //   if (a.degree < b.degree)
			 //      return true;
			 //  else if (a.degree == b.degree)
			 //     return r.ranU01()>0.5;
			 // else
			 //     return false;
			 if (r->ranU01()>0.5)
			 return true;
			 else
			 return false;
			 }*/
			else
				return false;
		} else
			return false;
	}
	;

protected:
	// Random *r;
};

class solHashed {
public:
	friend std::ostream& operator<<(std::ostream& os, const solHashed&);
	solHashed() {
	}
	;
	solHashed(Longint h, Longint i) :
		hash(h), iter(i) {
	}
	;
	~solHashed() {
	}
	;
	Longint hash;
	Longint iter;
};

class HashForTabu {
public:
	HashForTabu(Vertex n, Color c);
	~HashForTabu();
	Longint compute_hash_value(const Coloring &key);
	Longint compute_hash_value_incrementally(const Coloring &st, ColMove &mv);
	void update_data(const Coloring &st, ColMove &mv);
	Bool insert_in_hash_table(Longint tt);
	Bool is_in_hash_table(Longint hash_value);
	void init_hash_table();
	Longint get_current_hash_value() { return current_hash_value;};
	void set_current_hash_value(Longint h) { current_hash_value=h;};
private:
	vector<Longint> hashnum_vertices;
	vector<Longint> hashnum_classes;
	Vertex n_vertices;
	Color n_colors;
	vector<Longint> value_per_color;
	std::vector<std::list<solHashed > *> hash_table;
	compare_sum_per_colors *cmpr;
	Longint current_hash_value;
};

#endif /* HASH_H_ */
