#include "Runners.h"
#include "Explorer.h"
#include "TabuList.h"


void MinConflicts::Run(CompleteColoring &initial_ass) {
	p_ctrl->getOutputStream() << "MinConflicts\n";
	InitializeRun();
	CompleteColoring current_state(initial_ass);
	ColMove mv;
	bool tl_created = false;

	if (p_tl == NULL) {
		p_tl = new TabuListMinConf(p_in->Vertices(),
				current_state.CurrColors(), rg, p_ctrl);
		tl_created = true;
	} else
		p_tl->Init(p_in->Vertices(), current_state.CurrColors(), rg, p_ctrl);

	while ((current_state.cost != 0) && !(MaxIterationExpired())
			&& (idle_iterations < max_idle_iteration) && p_ctrl->isTimeLeft()) {
		UpdateIterationCounter();
		p_ne->BestMove(current_state, mv, *p_tl, number_of_iterations,
				initial_ass.cost);
#ifdef TEST_RUNNER
		CompleteColoring test_state(current_state);

		        if (!(test_state == current_state))
		  	{
		  	  cerr<<"before"<<endl;
		  	  exit(1);
		  	}
#endif
		p_tl->UpdateTabuList(current_state, mv, number_of_iterations);
		p_ne->MakeMove(current_state, mv);
#ifdef TEST_RUNNER
		p_ne->MakeMove(test_state, mv);
		//      test_state.col[mv.seq[0]] = mv.seq[1];

		//current_state.cost += mv.delta;

		        p_sm->updateColoringData(test_state);

		//        cout<<mv<<endl;
		        if (!(test_state == current_state))
			{
		  	  exit(1);
		  	}
#endif
		//        cout << current_state;
		if (current_state.cost != 0)
			current_state.feasible = false;
		else
			current_state.feasible = true;
		if (current_state.cost < initial_ass.cost) {
			initial_ass = current_state;
			p_ctrl->setCurrentCost(current_state.cost,
					current_state.CurrColors(), number_of_iterations);
			idle_iterations = 0;
		}
		idle_iterations++;

	}
	//  cout<<(current_state.cost != 0)<<" "<<!(MaxIterationExpired())<<" "<<
	//      (idle_iterations < max_idle_iteration)<<" "<<p_ctrl->isTimeLeft()<<endl;
	//    cout<<NumberOfIterations()<<" "<<max_iteration<<endl;
	TerminateRun();
	if (tl_created) {
		delete p_tl;
		p_tl = NULL;
	}
	p_ctrl->getOutputStream() << "Done (MinConflicts)\n";
}



//for MinConflicts!!!!
void ColOneExMinConfExplorer::BestMove(const CompleteColoring& coloring,

		ColMove& rc, TabuList &t_l, unsigned long iter, fvalue best_so_far) {
	//const Graph &g = *p_in; // g is an alias for the input Graph
	fvalue min = FVALUE_MAX;
	VertexSet::iterator pt;
	vector < pair<Vertex, Color> > candidates;
	fvalue delta;

	rc.seq.clear();
	rc.seq.resize(2);
	rc.type = ONE_EX;

	//select one node in conflict randomly
	int max = rg->ran0N(coloring.conflicts_set.size() - 1);
	pt = coloring.conflicts_set.begin();
	for (int i = 0; i < max; i++, pt++)
		;

	//select for the node the best color
	for (Color j = 0; j < coloring.CurrColors(); j++) {
		//if (coloring.col[*pt]==j)
		{
			if (coloring.col[*pt] == j)
				delta = 0;
			else
				delta = coloring.Delta(*pt, j);
			if (delta == min) {
				if ((!t_l.isTabu(*pt, j, iter)) || (coloring.cost + delta
						< best_so_far)) {
					pair<Vertex, Color> initPair;
					initPair.first = *pt;
					initPair.second = j;
					candidates.push_back(initPair);
				}
			} else if (delta < min) {
				if ((!t_l.isTabu(*pt, j, iter)) || (coloring.cost + delta
						< best_so_far)) {
					candidates.clear();
					pair<Vertex, Color> initPair;
					initPair.first = *pt;
					initPair.second = j;
					candidates.push_back(initPair);
					min = delta;
				}
			}
		}
	}

	//select randomly among the best colors for the node
	if (candidates.size() > 0) {
		int rnd = rg->ran0N(candidates.size() - 1);
		rc.seq[0] = candidates[rnd].first;
		rc.seq[1] = candidates[rnd].second;
		rc.delta = min;
		//rc.seq.push_back(coloring.col[rc.seq[0]]);
	} else {
		// do {
		rc.seq[0] = rg->ran0N(p_in->Vertices() - 1);
		rc.seq[1] = rg->ran0N(coloring.CurrColors() - 1);
		//} while (rc.seq[1]==coloring.col[rc.seq[0]]);
		if ( ((Color) rc.seq[1]) == coloring.col[rc.seq[0]])
			rc.delta = 0;
		else
			rc.delta = coloring.Delta(rc.seq[0], rc.seq[1]);
	}
}
