/*
 * Move.cpp
 *
 *  Created on: Jul 22, 2010
 *      Author: marco
 */

#include "Move.h"


ColMove::ColMove()
{
  seq.clear();
  type = NOT_DEFINED;
  delta = 0;
}

ColMove::ColMove(const ColMove& a)
{
  seq = a.seq;
  type = a.type;
  delta = a.delta;
}

ColMove& ColMove::operator=(const ColMove& a)
{
  seq = a.seq;
  type = a.type;
  delta = a.delta;
  return *this;
}


bool ColMove::operator==(const ColMove &a)
{
  if (type != a.type)
    return false;
  if (seq != a.seq)
    return false;
  if (delta != a.delta)
    return false;
  return true;
}



std::ostream& operator<<(std::ostream& os, const ColMove& mv)
{
  os <<"Type: " << mv.type;
  if (mv.type != 1)
    {
      os <<" Length: "<<mv.seq.size() << " Seq: ";
      for(vector<int>::const_iterator pt = mv.seq.begin();
	  pt != mv.seq.end(); pt++)
	{
	  os<<*pt<<" ";
	}
    }
  else
    {
      os <<" Length: "<<mv.seq.size()-1 << " Seq: ";
      for(int pt = 0; pt < 2; pt++)
	{
	  os<<mv.seq[pt]<<" ";
	}
    }
  os <<"Cost: "<<mv.delta;

  return os;
}
