#include "Runners.h"
#include "Explorer.h"
#include "TabuList.h"


/* Version used for the paper
 //for Novelty+!!!!
 void ColOneExNoveltyExplorer::BestMove(const Coloring& coloring, ColMove& rc,
 TabuList &t_l, unsigned long iter,
 fvalue best_so_far)
 {
 //const Graph &g = *p_in; // g is an alias for the input Graph
 fvalue min = FVALUE_MAX;
 unsigned long int min_age = LONG_MAX;
 unsigned long int max_age = 0;
 unsigned long rnd;

 VertexSet::iterator pt;
 vector < pair<Vertex, Color> > candidates;
 vector < pair<Vertex, Color> > oldest_candidates;
 fvalue delta;

 rc.seq.clear();
 rc.seq.resize(2);
 rc.type= 1;


 double wp = 0.01;
 double prob = t_l.prob;

 if (rg->next() < (wp))
 {
 do {
 rc.seq[0]=rg->ran0N(p_in->Vertices()-1);
 rc.seq[1]=rg->ran0N(coloring.CurrColors()-1);
 } while (rc.seq[1]==coloring.col[rc.seq[0]]);
 rc.delta = coloring.Delta(rc.seq[0],rc.seq[1]);
 //cout<<"*";
 return;
 }
 else
 {
 int max = rg->ran0N(coloring.conflicts_set.size()-1);
 pt = coloring.conflicts_set.begin();
 for (int i = 0;
 i < max; i++, pt++);
 for (Color j=0 ; j < coloring.CurrColors() ; j++) {
 if ( j != coloring.col[*pt])
 {
 if (t_l.IterTabu(*pt,j) < min_age)
 min_age = t_l.IterTabu(*pt,j);

 if (t_l.IterTabu(*pt,j) == max_age)
 {
 max_age = t_l.IterTabu(*pt,j);
 oldest_candidates.push_back(pair<Vertex, Color>(*pt,j));
 }
 else if (t_l.IterTabu(*pt,j) > max_age)
 {
 oldest_candidates.clear();
 max_age = t_l.IterTabu(*pt,j);
 oldest_candidates.push_back(pair<Vertex, Color>(*pt,j));
 }
 
 delta = coloring.Delta(*pt,j);
 if (delta == min) {
 pair<Vertex, Color> initPair;
 initPair.first = *pt ;
 initPair.second = j ;
 candidates.push_back(initPair);
 }
 if (delta < min)  {
 candidates.clear();
 pair<Vertex, Color> initPair;
 initPair.first = *pt ;
 initPair.second = j ;
 candidates.push_back(initPair);
 min = delta;
 }
 }
 }
 }

 if (candidates.size() == 1)
 {
 if (t_l.IterTabu(candidates[0].first,candidates[0].second) == min_age)
 {
 if (rg->next()<1-prob)
 {
 rc.seq[0] = candidates[0].first;
 rc.seq[1] = candidates[0].second;
 rc.delta = min;
 //cout<<"+";
 return;
 }
 else
 {
 int rnd = rg->ran0N(candidates.size()-1);
 rc.seq[0] = oldest_candidates[rnd].first;
 rc.seq[1] = oldest_candidates[rnd].second;
 rc.delta = coloring.Delta(rc.seq[0],rc.seq[1]);
 //cout<<"-";
 return;
 }
 }
 else
 {
 rc.seq[0] = candidates[0].first;
 rc.seq[1] = candidates[0].second;
 rc.delta = min;
 //cout<<"+";
 return;
 }
 }
 else if (candidates.size()>0)
 {
 do
 {
 rnd = rg->ran0N(candidates.size()-1);
 } while ((t_l.IterTabu(candidates[rnd].first,candidates[rnd].second)
 == min_age) && (rg->next()<prob));
 rc.seq[0] = candidates[rnd].first;
 rc.seq[1] = candidates[rnd].second;
 rc.delta = min;
 //cout<<"-";
 return;
 //rc.seq.push_back(coloring.col[rc.seq[0]]);
 }
 else
 {
 cerr<<"Somthing strange in Novelty+ BestMove selection\n";
 do {
 rc.seq[0]=rg->ran0N(p_in->Vertices()-1);
 rc.seq[1]=rg->ran0N(coloring.CurrColors()-1);
 } while (rc.seq[1]==coloring.col[rc.seq[0]]);
 rc.delta = coloring.Delta(rc.seq[0],rc.seq[1]);
 }
 }
 */

void NoveltyRunner::Run(CompleteColoring &initial_ass) {
	 p_ctrl->getOutputStream() << "Novelty\n";
	InitializeRun();
	CompleteColoring current_state(initial_ass);
	ColMove mv;

	HistoryNovelty tl(p_in->Vertices(), current_state.CurrColors(), rg, p_ctrl);
	tl.prob = p_ctrl->prob;
	while ((current_state.cost != 0) && !(MaxIterationExpired())
			&& (idle_iterations < max_idle_iteration) && p_ctrl->isTimeLeft()) {
		UpdateIterationCounter();
		p_ne->BestMove(current_state, mv, tl, number_of_iterations,
				initial_ass.cost);
#ifdef TEST_RUNNER
		CompleteColoring test_state(current_state);
		//cout << test_state<<endl;
		if (!(test_state == current_state)) {
			cerr << "before" << endl;
			exit(1);
		}
		cout << mv << endl;
#endif
		tl.UpdateTabuList(current_state, mv, number_of_iterations);
		p_ne->MakeMove(current_state, mv);
#ifdef TEST_RUNNER
		p_ne->MakeMove(test_state, mv);
		//test_state.col[mv.seq[0]] = mv.seq[1];

		//	  current_state.cost += mv.delta;

		p_sm->updateColoringData(test_state);
		//cout << test_state<<endl;
		if (!(test_state == current_state)) {
			exit(1);
		}
		//cerr<<mv.delta<<" "<<current_state.cost<<" "<<number_of_iterations<<endl;
		//cout << current_state;
#endif
		if (current_state.cost != 0)
			current_state.feasible = false;
		else
			current_state.feasible = true;

		if (current_state.cost < initial_ass.cost) {
			initial_ass = current_state;
			p_ctrl->setCurrentCost(current_state.cost,
					current_state.CurrColors(), number_of_iterations);
			idle_iterations = 0;
		}
		idle_iterations++;
	}
	TerminateRun();
	p_ctrl->getOutputStream() << "Done (Novelty)\n";
}


 //for Novelty+!!!!
 void ColOneExNoveltyExplorer::BestMove(const CompleteColoring& coloring,
 		ColMove& rc, TabuList &t_l, unsigned long iter, fvalue best_so_far) {
 	//const Graph &g = *p_in; // g is an alias for the input Graph
 	fvalue min = FVALUE_MAX;
 	unsigned long int min_age = LONG_MAX;
 	fvalue second_min = FVALUE_MAX;
 	unsigned long rnd;

 	VertexSet::iterator pt;
 	vector < pair<Vertex, Color> > candidates;
 	vector < pair<Vertex, Color> > second_candidates;
 	fvalue delta;

 	rc.seq.clear();
 	rc.seq.resize(2);
 	rc.type = ONE_EX;

 	double wp = 0.0;
 	double prob = t_l.prob;

 	if (rg->next() < (wp)) {
 		do {
 			rc.seq[0] = rg->ran0N(p_in->Vertices() - 1);
 			rc.seq[1] = rg->ran0N(coloring.CurrColors() - 1);
 		} while (((Color) rc.seq[1]) == coloring.col[rc.seq[0]]);
 		rc.delta = coloring.Delta(rc.seq[0], rc.seq[1]);
 		//cout<<"*";
 		return;
 	} else {
 		int max = rg->ran0N(coloring.conflicts_set.size() - 1);
 		pt = coloring.conflicts_set.begin();
 		for (int i = 0; i < max; i++, pt++)
 			;
 		for (Color j = 0; j < coloring.CurrColors(); j++) {
 			if (j != coloring.col[*pt]) {
 				if (t_l.IterTabu(*pt, j) < min_age)
 					min_age = t_l.IterTabu(*pt, j);

 				delta = coloring.Delta(*pt, j);
 				//cout<<"."<<delta;
 				if (delta <= min) {
 					if (delta < min) {
 						second_candidates = candidates;
 						second_min = min;
 						candidates.clear();
 						candidates.push_back(pair<Vertex, Color> (*pt, j));
 					} else {
 						candidates.push_back(pair<Vertex, Color> (*pt, j));
 					}

 					min = delta;
 				} else if (delta <= second_min) {
 					if (delta < second_min) {
 						second_candidates.clear();
 						second_candidates.push_back(
 								pair<Vertex, Color> (*pt, j));
 					} else {
 						second_candidates.push_back(
 								pair<Vertex, Color> (*pt, j));
 					}
 					second_min = delta;
 				}
 			}
 		}
 	}

 	//cout<<">"<<min<<" "<<candidates.size()<<" "
 	//  <<second_min<<" "<<second_candidates.size()<<endl;
 	if (candidates.size() == 1) {
 		if (t_l.IterTabu(candidates[0].first, candidates[0].second) == min_age) {
 			if (rg->next() < 1 - prob) {
 				rc.seq[0] = candidates[0].first;
 				rc.seq[1] = candidates[0].second;
 				rc.delta = min;
 				//cout<<"+"<<endl;
 				//cout<<rc<<endl;
 				return;
 			} else {
 				//cout<<second_candidates.size()<<endl;
 				int rnd = rg->ran0N(second_candidates.size() - 1);
 				rc.seq[0] = second_candidates[rnd].first;
 				rc.seq[1] = second_candidates[rnd].second;
 				rc.delta = second_min;//coloring.Delta(rc.seq[0],rc.seq[1]);
 				//cout<<"-"<<endl;
 				return;
 			}
 		} else {
 			rc.seq[0] = candidates[0].first;
 			rc.seq[1] = candidates[0].second;
 			rc.delta = min;
 			//cout<<"++"<<endl;
 			return;
 		}
 	} else if (candidates.size() > 0) {
 		do {
 			rnd = rg->ran0N(candidates.size() - 1);
 		} while ((t_l.IterTabu(candidates[rnd].first, candidates[rnd].second)
 				== min_age) && (rg->next() < prob));
 		rc.seq[0] = candidates[rnd].first;
 		rc.seq[1] = candidates[rnd].second;
 		rc.delta = min;
 		//cout<<"--"<<endl;
 		return;
 		//rc.seq.push_back(coloring.col[rc.seq[0]]);
 	} else {
 		cerr << "Something strange in Novelty+ BestMove selection\n";
 		do {
 			rc.seq[0] = rg->ran0N(p_in->Vertices() - 1);
 			rc.seq[1] = rg->ran0N(coloring.CurrColors() - 1);
 		} while ( ((Color) rc.seq[1]) == coloring.col[rc.seq[0]]);
 		rc.delta = coloring.Delta(rc.seq[0], rc.seq[1]);
 	}

 }
