#include <fstream>
#include "Runners.h"
#define CHARBITS  8

using namespace std;

//#define TRIAL_NUM  640	/* default number of sets tried per color */
//#define EXACTLIM  70
double MAX_RANGE = 0.2;
inline double cube(double x) {return (x*x*x);};
inline double square(double x) {return (x*x);};
inline double regression(double x) {return square(15.5*x + 4.7);};

inline bool criterion(double d, Vertex s, double r) {
	if (d > 0.1)
	{
		return ((s > 100) || (r > MAX_RANGE || (s > regression(d))));
	}
	else
	{
		return (s > 25);
	}
};
//int XRLF::edge(int x,int y) {return 
//(Bitmap[(y)/CHARBITS][(x)] & (1<<((y)%CHARBITS)));};



void XRLF::exhaustive_search(register vector<Vertex> &Wi,
		register Vertex size,
		register list<Vertex> &Wprime,
		register list<Vertex> &Wstar,
		register Vertex current_cost)
{
	register Vertex p = 0;
	//cout<<current_cost<<" "<<size<<" "<<Wi.size()<<" "<<Wprime.size()<<" "<<Wstar.size()<<endl;

	while ( p != size )
	{
		register Vertex v = Wi[p];
		register vector<Vertex> newW(size);
		register Vertex new_size = 0;
		register Vertex new_cost = current_cost+worth_edges[v];

		for (unsigned int i = p+1 ; i < size; i++)
		{
			if (!edge(Wi[i],v))
			{
				newW[new_size++] = Wi[i];
			}
		}


		Wprime.push_back(v);

		if (new_cost > best_edges)
		{
			Wstar = Wprime;
			best_edges = new_cost;
			// 	  if (p_ctrl->test_version)
				//  	    {
			//  	      cout<<"-->["<<best_edges<<"] ";
			//  	      for (unsigned int a=0; a < N; a++)
			//  		{
			//  		  if (Wstar[a])
			//  		    cout<<a<<" ";
			//  		}
			//  	      cout<<endl;
			//  	      if (!check(Wstar))
			//  		{
			//  		  cout<<"after cand num"<<endl;
			//  		  exit(1);
			//  		}
			// 	    }
		}
		else if (new_cost == best_edges
				&& Wstar.size() < Wprime.size())
		{
			Wstar = Wprime;
		}

		exhaustive_search(newW,new_size,Wprime,Wstar,new_cost);
		p++;
		Wprime.pop_back();
	}
}


bool XRLF::check (list<Vertex> &a)
{
	/* checks that the vertices with color K are an independent set */
	register list<Vertex>::iterator p1,p2;

	for (p1 = a.begin(); p1 != a.end(); p1++)
		for (p2 = a.begin(); p2 != a.end(); p2++)
		{
			if ((*p1) != (*p2) && edge((*p1),(*p2)))
			{
				printf ("edge (%d,%d) in set\n",
						(*p1),(*p2));
				return false;
			}
		}
	return true;
}


bool XRLF::check (vector<Vertex> &a)
{
	/* checks that the vertices with color K are an independent set */
	register Vertex i,j;

	for (i = 0; i < N; i++)
	{
		if (a[i])
		{
			for (j = 0 ; j < N; j++)
			{
				if (a[j])
				{
					if (i != j && edge(i,j))
					{
						printf ("edge (%d,%d) in set\n",
								i,j);
						return false;
					}
				}
			}
		}
	}
	return true;
}




void XRLF::findMaxIndepSet(Vertex Grsize)//VertexSet &indep_set)
{

	register Vertex v,node;

	N = Grsize;

	bool Cstar_empty = true;
	bool N_bigger_setlim = true;

	list<Vertex> X,C;
	register list<Vertex>::iterator p;
	register vector<Vertex> W(N);
	register vector<Vertex> Wdegree(N);
	register Vertex Wsize = 0;
	register vector<Vertex> UminusC(N,1);

	register int residual_edges=0;
	register double density=0,range=0;
	register Vertex degmin=N,degmax=0;

	bool Czero = false;//.clear();
	//U.clear();


	int best = -1;

	Vertex v_max;


	/* initialize vertex and degree arrays */
	//1.--------------------------------------------------
	/*for (Vertex i = 0; i < (unsigned) (N/CHARBITS+1); i++)
    {
    for (Vertex j = 0; j < (unsigned) (N); j++)
    Bitmap[i][j] = '\0';
    //memset(Bitmap,0,(NMAX+1)*sizeof(unsigned char));
    //memset(nvertex,0,(NMAX+1)*sizeof(int));
    }

    for (Vertex i = 0; i < (unsigned) N; i++)
    {
    Vertex Degree = 0;
    for (Vertex j = 0; j < (unsigned) N; j++)
    {
    if (p_in->Edge(Gr[i],Gr[j]))//get_edge(i, j))
    {
    Bitmap[(j)/CHARBITS][i] |= (1 << ((j) % CHARBITS));
    //cout<<edge(i,j)<<":";
    Degree++;
    }
    else if (i==j)
    {
    Bitmap[(j)/CHARBITS][i] |= (1 << ((j) % CHARBITS));
    //	cout<<edge(i,j)<<":";
    }
    //   if (i!=j && p_in->Edge(Gr[i],Gr[j]) != edge(i,j))
    //  		{
    //  		  cerr<<"ruf die polizei"<<p_in->Edge(Gr[i],Gr[j])<<" "
    //  		      <<" "<<edge(i,j)<<" "<<i<<" "<<Gr[i]<<" "<<j<<" "<<
    //  		    Gr[j]<<endl;
    //  		  exit(1);
    //  		}
    }
	 */
	v_max=0;
	residual_edges = degmax = degmin = degree[Gr[0]];
	for (Vertex i = 1; i < (unsigned) N; i++)
	{
		residual_edges += degree[Gr[i]];
		if (degmax < degree[Gr[i]])
		{
			v_max=i;
			degmax = degree[Gr[i]];
		}
		if (degmin > degree[Gr[i]])
		{
			degmin = degree[Gr[i]];
		}
		Cstar[i] = 0;
	}

	density = (double) (residual_edges)/(N*N);
	double range_i = (double) (degmax-degmin)/N;

	if ( !criterion(density,N,range) )
		N_bigger_setlim = false;

	//cout<<"enter\n";
	//2.--------------------------------------------------
	if (trialnum == 1 && N_bigger_setlim)
	{
		Czero = true; //.insert(v_max);
	}
	//3.--------------------------------------------------
	if (min(trialnum,(regression(density)+degmin)) >= N)
	{
		trialnum = 1;
	}
	if (!N_bigger_setlim)
	{
		trialnum = 1;
	}
	//4.--------------------------------------------------
	for (unsigned int trial = 0; trial < trialnum; trial++)
	{
		range=range_i;
		Wsize = 0;
		//       if (p_ctrl->test_version)
		//cout<<"4 ("<<N<<")"<<endl;
		//4.1-------------------------------------------
		//W = U;
		if (Czero) //.size() > 0)
		{
			// 	  if (p_ctrl->test_version)
			//cout<<"4.1a"<<endl;
			C.clear();
			C.push_back(v_max);
			X.clear();

			Wsize=0;
			residual_edges=0;
			for (unsigned int j = 0;j<N; j++)
			{
				if (j!=v_max)
				{
					UminusC[j]=1;
					if (edge(j,v_max))
					{
						X.push_back(j);
					}
					else
					{
						Wdegree[Wsize]=0;
						W[Wsize] = j;
						for (unsigned int y = 0; y < (Wsize); y++)
						{
							if (edge(j,W[y]))
							{
								Wdegree[y]++;
								Wdegree[Wsize]++;
								residual_edges++;
							}
						}
						Wsize++;
					}
				}
				else
					UminusC[v_max]=0;
			}
			degmin=Wsize,degmax=0;
			for (unsigned int j = 0; j < Wsize; j++)
			{
				if (degmin > Wdegree[j])
					degmin=Wdegree[j];
				if (degmax < Wdegree[j])
					degmax=Wdegree[j];
			}
			density = (double) (2*residual_edges)/(Wsize*(Wsize-1));
			range = (double) (degmax-degmin)/Wsize;
		}
		else if (N_bigger_setlim)
		{//Czero.size=0
			// 	  if (p_ctrl->test_version)
			//cout<<"4.1b"<<endl;
			v = rg->ran0N(N-1);
			C.clear();
			X.clear();
			C.push_back(v);
			//cout<<v<<" "<<degree[Gr[v]]<<endl;
			Wsize = 0;
			residual_edges = 0;
			for (unsigned int j = 0;j<N; j++)
			{
				if (j!=v)
				{
					UminusC[j]=1;
					if (edge(j,v))
						X.push_back(j);
					else
					{
						Wdegree[Wsize]=0;
						W[Wsize] = j;
						for (unsigned int y = 0; y < Wsize; y++)
						{
							if (edge(j,W[y]))
							{
								Wdegree[y]++;
								Wdegree[Wsize]++;
								residual_edges++;
							}
						}
						Wsize++;
					}
				}
				else
					UminusC[v]=0;
			}
			degmin=Wsize,degmax=0;
			for (unsigned int j = 0; j < Wsize; j++)
			{
				if (degmin > Wdegree[j])
					degmin=Wdegree[j];
				if (degmax < Wdegree[j])
					degmax=Wdegree[j];
			}
			density = (double) (residual_edges)/(Wsize*(Wsize-1));
			range = (double) (degmax-degmin)/Wsize;
		}
		else
		{
			// 	  if (p_ctrl->test_version)
			//cout<<"4.1c"<<endl;
			C.clear();
			X.clear();
			Wsize=0;
			residual_edges = 0;
			for (unsigned int j = 0;j<N; j++)
			{
				UminusC[j]=1;
				W[Wsize++] = j;
				residual_edges += degree[Gr[j]];
			}
			density = (double) (residual_edges)/(Wsize*Wsize);
		}
		//4.2--------------------------------------------
		//4.3-------------------------------------------
		//range=0;
		//density = (double) (residual_edges)/(Wsize*(Wsize-1));

		//while (Wsize > 40 || range > 0.8)// || density < 0.05 )
		while (density > 0 && ( criterion(density,Wsize,range))) //while (Wsize > setlim)
		{
			//cout<<Wsize<<endl;
			//4.3.2++++++++++++++++++++
			register int bestdegree = -1;
			Vertex cand = N;

			for (unsigned int z=0; z < candnum; z++)
			{
				// 	      if (p_ctrl->test_version)
				// 		cout<<"4.3.2"<<endl;
				register Vertex u = W[rg->ran0N(Wsize-1)];

				register int su = 0;
				for (p = X.begin(); p!=X.end(); p++)
				{
					if (edge(*p,u))
					{
						su++;
					}
				}
				if (su > bestdegree)
				{
					bestdegree = su;
					cand = u;
				}
			}
			//cout<<cand<<" "<<degree[Gr[cand]]<<" "<<bestdegree<<endl;
			//4.3.3++++++++++++++++++++
			// 	  if (p_ctrl->test_version)
			//cout<<"4.3.3"<<endl;

			C.push_back(cand);
			UminusC[cand]=0;
			Vertex newWsize = 0;
			residual_edges=0;

			for (unsigned int j = 0; j < Wsize; j++)
			{
				node = W[j];

				if (node!=cand)
				{
					if (edge(node,cand))
					{
						X.push_back(node);
					}
					else
					{
						Wdegree[newWsize]=0;
						W[newWsize]=node;
						for (unsigned int y = 0; y < newWsize; y++)
						{
							if (edge(node,W[y]))
							{
								Wdegree[y]++;
								Wdegree[newWsize]++;
								residual_edges++;
							}
						}
						newWsize++;
					}
				}
			}
			Wsize = newWsize;
			degmin=Wsize,degmax=0;
			for (unsigned int j = 0; j < Wsize; j++)
			{
				if (degmin > Wdegree[j])
					degmin=Wdegree[j];
				if (degmax < Wdegree[j])
					degmax=Wdegree[j];
			}
			range = (double) (degmax-degmin)/Wsize;

			// 	  if (p_ctrl->test_version)
			// 	    {
			// 	      if (!check(C))
			// 		{
			// 		  cout<<"after cand num"<<endl;
			// 		  exit(1);
			// 		}
			// 	    }
			density = (double) (2 * residual_edges)/(Wsize*(Wsize-1));
			//cout<<Wsize<<" "<<range<<" "<<density<<" "<<degmin<<" "<<degmax<<endl;
		}
		//cout<<trial<<endl;
		//4.3.1++++++++++++++++++++
		//       if (p_ctrl->test_version)
		//cout<<"4.3.1"<<endl;
		register list<Vertex> Wprime;
		register list<Vertex> Wstar;



		//register VertexSet::iterator pt;
		for (unsigned int a=0; a < Wsize; a++)
		{
			node = W[a];
			worth_edges[node]=0;
			for (unsigned int b=0; b<N; b++)
				if (node!=b && UminusC[b] && edge(node,b))
					worth_edges[node]++;
		}

#ifdef TEST_RUNNER

			degmin=Wsize,degmax=0;
			Vertex cmin=0,cmax=0;
			double total = 0;
			double totalsq = 0;
			for (unsigned int a=0; a < Wsize; a++)
			{
				Wdegree[a]=0;
				residual_edges=0;
				for (unsigned int b=0; b < Wsize; b++)
				{
					if (edge(W[a],W[b]))
					{
						Wdegree[a]++;
						residual_edges++;
					}
				}
				total += Wdegree[a];
				totalsq += (Wdegree[a]*Wdegree[a]);




				if (degmin > Wdegree[a])
				{
					cmin=1;
					degmin=Wdegree[a];
				}
				else if (degmin == Wdegree[a])
				{
					cmin++;
				}
				if (degmax < Wdegree[a])
				{
					cmax=1;
					degmax=Wdegree[a];
				}
				if (degmax == Wdegree[a])
				{
					cmax++;
				}
			}
			range = (double) (degmax-degmin)/Wsize;

			//sum_sd = sqrt(sum_sd/Wsize);
			//      if (p_ctrl->test_version)
			cout<<"exhaustive search "<<Wsize<<" "<<density << " "
					<<sqrt((totalsq-(2*total/Wsize*total)+(total/Wsize*total))/Wsize)/Wsize
					<<" "<<range<<" "
					<<(degmax+degmin)/2<<" "<<degmin<<" "<<degmax
					<< " "<<(double) (cmin+cmax)/Wsize<<endl;
#endif

		if (density > 0)
		{

			/*	  	  char jn[1];
			  do {
			  cout<<"Continue? (y,n)"<<endl;
			  cin>>jn;
			  } while ((jn)=="y" || (jn) =="n");
			  if ((jn)=="n")
			  exit(1);
			 */
#ifdef PROFILE_XRLF

			ofstream ooo("og.tlp");
			ooo<<"(nodes ";
			for (Vertex v = 0; v < Wsize; v++)
			{
				ooo<<W[v]<<" ";
			}
			ooo << ")\n";
			int count = 0;
			for (Vertex v = 0; v < Wsize; v++)
			{
				for (Vertex u = v+1; u < Wsize; u++)
				{
					if (edge(W[u],W[v]))
						ooo<<"(edge "<<count++<< " "<<W[v]<<" "<<W[u]<<")\n";
				}
			}
			ooo<<"(property  0 layout \"viewLayout\"\n";
			ooo<<"(default \"(0,0,0)\" \"()\" )\n";
			//double pi = 3.1415926535;
			//double delta = 2*pi/G.Vertices();
			//double angle = 0;
			for (Vertex v = 0; v < Wsize; v++)
			{
				ooo<<"(node "<<v
						//<<" \"("<<100*cos(angle)
						// <<","<<100*sin(angle)<<",0)\""
						<<")\n";
				//angle += delta;
			}
			ooo<<")\n";

			//    ooo<<"(property  0 string \"viewLabel\"\n";
			//    ooo<<"(default \"\" \"\" )\n";
			//    for (Vertex v = 0; v < G.Vertices(); v++)
			//     {
			//       ooo<<"(node "<<v<<" ";
			//       if (G.assigned[v]<0)
			// 	ooo<<"\"U\")\n";
			//       else
			// 	ooo<<"\"C\")\n";
			//     }
			ooo<<")\n";

			ooo.close();
#endif




			best_edges = 0;
			exhaustive_search(W,Wsize,Wprime,Wstar,0);

			int edges = 0;
			for (p = C.begin(); p!=C.end(); p++)
				for (unsigned int j=0; j<N; j++)
					if (UminusC[j] && edge((*p),j))
						edges++;

			if ((int) (edges+best_edges) > best)
			{
				for (Vertex i = 0; i < N; i++)
					Cstar[i] = 0;
				for (p = Wstar.begin(); p!=Wstar.end(); p++)
					Cstar[*p] = 1;//Wstar;
				for (p = C.begin(); p!=C.end(); p++)
					Cstar[*p] = 1;
				// 	  if (p_ctrl->test_version)
				// 	    {
				// 	      if (!check(Cstar))
				// 		{
				// 		  cout<<"after exaustive num"<<endl;
				// 		  exit(1);
				// 		}
				// 	    }
				Cstar_empty = false;
				best = edges+best_edges;
			}
		}
		else
		{
			best_edges=0;
			for (unsigned int a=0; a < Wsize; a++)
			{
				best_edges+=worth_edges[W[a]];
			}
			//Wstar=W;
			int edges = 0;
			for (p = C.begin(); p!=C.end(); p++)
				for (unsigned int j=0; j<N; j++)
					if (UminusC[j] && edge((*p),j))
						edges++;
			if ((int) (edges+best_edges) > best)
			{
				for (Vertex i = 0; i < N; i++)
					Cstar[i] = 0;
				for (unsigned int a=0; a < Wsize; a++)
					Cstar[W[a]] = 1;//Wstar;
				for (p = C.begin(); p!=C.end(); p++)
					Cstar[*p] = 1;
				// 	  if (p_ctrl->test_version)
				// 	    {
				// 	      if (!check(Cstar))
				// 		{
				// 		  cout<<"after exaustive num"<<endl;
				// 		  exit(1);
				// 		}
				// 	    }
				Cstar_empty = false;
				best = edges+best_edges;
			}
		}

	}


	if (Cstar_empty)
	{
		cerr<<"strange case!!\n";
		for (p = C.begin(); p!=C.end(); p++)
		{
			Cstar[*p] = 1;
		}
	}

}



//------------------------------------------------------------


XRLF::XRLF(ColoringManager* s, Random *rnd, Control *ctrl, Graph* in = NULL):
		  ColoringRunner(s,rnd,ctrl,in)
{
	/* unsigned int x = (in->Vertices()/CHARBITS+1);
  Bitmap = new unsigned char *[x];
  for (Vertex i = 0; i < x; i++)
  Bitmap[i] = new unsigned char[in->Vertices()];*/
	Gr.resize(in->Vertices(),0);
	degree.resize(in->Vertices());
	Cstar.resize(in->Vertices(),0);
	worth_edges.resize(in->Vertices(),0);
}

XRLF::~XRLF()
{
	/*for (Vertex i = 0; i < (p_in->Vertices()/CHARBITS+1); i++)
    delete [] Bitmap[i];
    delete [] Bitmap;*/
}






void XRLF::Run(Coloring &initial)
{
	Vertex num = p_in->Vertices();
	//vector<Vertex> R(num);

	Color K_I = 0;
	Color K_P = 0;

	Vertex Rsize = 0;
	for (Vertex i = 0; i< num; i++)
	{
		initial.col[i]=num+1;
		//R[Rsize++] = i;
		Gr[Rsize++] = i;
		degree[i] = p_in->degree[i];
	}

	while (Rsize > (Vertex) p_ctrl->exact_lim)
	{

		setlim = p_ctrl->set_lim;
		candnum = p_ctrl->cand_num;
		trialnum = p_ctrl->trial_num;

		//findMaxIndepSet(R,Rsize);
		findMaxIndepSet(Rsize);

#ifdef TEST_RUNNER
		if (!check(Cstar))
		{
			cout<<"this is in Test Run"<<endl;
			exit(1);
		}
#endif
		//VertexSet::iterator pt;
		Vertex newRsize=0;
		for (Vertex i = 0; i < Rsize; i++)
		{
			if (Cstar[i])
			{
				//initial.col[R[i]] = K_I;
				initial.col[Gr[i]] = K_I;
				VertexSet::iterator pt;
				for (pt=p_in->adjacency_set[Gr[i]].begin();
						pt!=p_in->adjacency_set[Gr[i]].end(); pt++)
				{
					degree[*pt]--;
				}

			}
			else
			{
				//R[newRsize++]=R[i];
				Gr[newRsize++]=Gr[i];
			}
		}
#ifdef TEST_RUNNER
		cout<<"++++ "<<Rsize<<" ++++++++++++++++ "<<Rsize-newRsize<<endl;
#endif
		Rsize = newRsize;
		K_I++;
	}
	initial.SetColors(K_I);


	if (Rsize!=0)
	{
		double time = p_ctrl->getTime();
		(p_ctrl->getOutputStream()).flags( ios::fixed );
		(p_ctrl->getOutputStream())<<"currentK "<<K_I<<" nodes_missing "<<Rsize<<" "<<" time "
				<<( time < 0 ? 0.0 : time )<<endl;

		//p_ctrl->SetColorsXRLF(K_I);
		if (!p_ctrl->isTimeLeft())
		{
			(p_ctrl->getOutputStream())<<"unfinished exit "<<( time < 0 ? 0.0 : time )<<endl;
			cout<<1<<" "<<0<<endl;
			exit(1);
		}

		BranchAndBound partialBB(rg,p_in,p_ctrl,initial);

#ifdef PROFILE_XRLF
		ofstream ooo("og-bb.tlp");
		ooo<<"(nodes ";
		for (Vertex v = 0; v < Rsize; v++)
		{
			ooo<<Gr[v]<<" ";
		}
		ooo << ")\n";
		int count = 0;
		for (Vertex v = 0; v < Rsize; v++)
		{
			for (Vertex u = v+1; u < Rsize; u++)
			{
				if (edge(Gr[u],Gr[v]))
					ooo<<"(edge "<<count++<< " "<<Gr[v]<<" "<<Gr[u]<<")\n";
			}
		}
		ooo<<"(property  0 layout \"viewLayout\"\n";
		ooo<<"(default \"(0,0,0)\" \"()\" )\n";
		//double pi = 3.1415926535;
		//double delta = 2*pi/G.Vertices();
		//double angle = 0;
		for (Vertex v = 0; v < Rsize; v++)
		{
			ooo<<"(node "<<Gr[v]
			                  //<<" \"("<<100*cos(angle)
			                  // <<","<<100*sin(angle)<<",0)\""
			                  <<")\n";
			//angle += delta;
		}
		ooo<<")\n";

		//    ooo<<"(property  0 string \"viewLabel\"\n";
		//    ooo<<"(default \"\" \"\" )\n";
		//    for (Vertex v = 0; v < G.Vertices(); v++)
		//     {
		//       ooo<<"(node "<<v<<" ";
		//       if (G.assigned[v]<0)
		// 	ooo<<"\"U\")\n";
		//       else
		// 	ooo<<"\"C\")\n";
		//     }
		ooo<<")\n";

		ooo.close();
#endif
		//K_P = partialBB.chrom_number(Rsize,R[0],
		//			   p_in->Vertices()+1,K_I);
		K_P = partialBB.chrom_number(Rsize,Gr[0],
				p_in->Vertices()+1,K_I);


		for (Vertex i = 0; i < p_in->Vertices(); i++)
		{
			//cout<<"("<<i<<","<<partialBB.best_C[i]<<")";
			initial.col[i] = partialBB.best_C[i];
			if (initial.col[i]> (Color) p_in->Vertices())
			{
				cout<<"Dies sollte nicht passieren!"<<endl;
				exit(1);
			}

		}
		//cout<<endl;

		initial.SetColors(K_P);
		p_sm->updateColoringData(initial);


	}
	else
	{
		p_sm->updateColoringData(initial);
		p_ctrl->setCurrentCost(initial.cost,initial.CurrColors(),0);
	}
}



